Bug 1564720 - Review Request: watchman - a file watching service
Summary: Review Request: watchman - a file watching service
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin 🐧
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: FE-DEADREVIEW
TreeView+ depends on / blocked
 
Reported: 2018-04-07 02:44 UTC by Lars Kellogg-Stedman
Modified: 2020-06-15 16:09 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-06-15 13:59:44 UTC
Type: ---
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Lars Kellogg-Stedman 2018-04-07 02:44:27 UTC
Spec URL: https://copr-be.cloud.fedoraproject.org/results/larsks/watchman/fedora-rawhide-x86_64/00738115-watchman/watchman.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/larsks/watchman/fedora-rawhide-x86_64/00738115-watchman/watchman-4.9.0-1.fc29.src.rpm
Description: Watchman exists to watch files and record when they change. It can also trigger actions (such as rebuilding assets) when matching files change.

Fedora Account System Username: larsks

Comment 1 Robert-André Mauchin 🐧 2018-04-07 13:39:24 UTC
 - Use %{_rundir} instead of /run

 - I don't think BuildRequires:  systemd is necessary.

 - Dubious files permissions:

watchman.x86_64: E: world-writable /run/watchman 2777
watchman.x86_64: E: non-standard-dir-perm /run/watchman 2777

Should probably be 0755.

 - Files in /run should be ghosted:

watchman.x86_64: W: non-ghost-in-run /run/watchman

 - This file should probably not included:

watchman.x86_64: W: non-ghost-in-run /run/watchman/.not-empty
watchman.x86_64: W: hidden-file-or-dir /run/watchman/.not-empty
watchman.x86_64: E: zero-length /run/watchman/.not-empty

 - Some parts are also BSD and MIT

BSD (3 clause)
--------------
watchman-4.9.0/python/pywatchman/__init__.py
watchman-4.9.0/python/pywatchman/bser.c
watchman-4.9.0/python/pywatchman/capabilities.py
watchman-4.9.0/python/pywatchman/compat.py
watchman-4.9.0/python/pywatchman/encoding.py
watchman-4.9.0/python/pywatchman/load.py
watchman-4.9.0/python/pywatchman/pybser.py
watchman-4.9.0/ruby/ruby-watchman/LICENSE.txt
watchman-4.9.0/ruby/ruby-watchman/ext/ruby-watchman/watchman.c
watchman-4.9.0/ruby/ruby-watchman/ext/ruby-watchman/watchman.h
watchman-4.9.0/thirdparty/libart/LICENSE
watchman-4.9.0/winbuild/getopt_long.cpp


MIT/X11 (BSD like) BSD (3 clause)
---------------------------------
watchman-4.9.0/python/LICENSE

   Add it to the License field and add a comment explaning the license breakdown.



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "Unknown or generated", "MIT/X11 (BSD like)
     BSD (3 clause)", "BSD (unspecified)", "*No copyright* BSD
     (unspecified)", "BSD (3 clause)", "BSD (2 clause)", "FSF All
     Permissive", "*No copyright* Apache (v2.0)". 240 files have unknown
     license. Detailed output of licensecheck in
     /home/bob/packaging/review/watchman/review-watchman/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[-]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/tmpfiles.d
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     watchman-python3
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Files in /run, var/run and /var/lock uses tmpfiles.d when appropriate
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Package should not use obsolete m4 macros
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: watchman-4.9.0-1.fc29.x86_64.rpm
          watchman-python3-4.9.0-1.fc29.x86_64.rpm
          watchman-debuginfo-4.9.0-1.fc29.x86_64.rpm
          watchman-debugsource-4.9.0-1.fc29.x86_64.rpm
          watchman-4.9.0-1.fc29.src.rpm
watchman.x86_64: W: only-non-binary-in-usr-lib
watchman.x86_64: W: non-ghost-in-run /run/watchman
watchman.x86_64: E: world-writable /run/watchman 2777
watchman.x86_64: E: non-standard-dir-perm /run/watchman 2777
watchman.x86_64: W: non-ghost-in-run /run/watchman/.not-empty
watchman.x86_64: W: hidden-file-or-dir /run/watchman/.not-empty
watchman.x86_64: E: zero-length /run/watchman/.not-empty
watchman.x86_64: W: no-manual-page-for-binary watchman
watchman.x86_64: W: no-manual-page-for-binary watchman-make
watchman.x86_64: W: no-manual-page-for-binary watchman-wait
watchman-python3.x86_64: W: no-documentation
watchman-debugsource.x86_64: W: no-documentation
watchman.src:41: W: mixed-use-of-spaces-and-tabs (spaces: line 1, tab: line 41)
5 packages and 0 specfiles checked; 4 errors, 10 warnings.

Comment 2 Robert-André Mauchin 🐧 2018-04-07 13:50:44 UTC
 - After reading how the program works (one instance per user), the permissions with setgid 2777 might be okay.

Comment 3 Lars Kellogg-Stedman 2018-04-11 01:22:12 UTC
> - Use %{_rundir} instead of /run

Done.

> - I don't think BuildRequires:  systemd is necessary.

Without that the %{_tmpfilesdir} macro is undefined.

> - Dubious files permissions:

Those are required.  It's basically just like /tmp.  I think the project should default to using the user's home directory rather than a global directory like that, but that's how it operates right now.

> - Files in /run should be ghosted:

Done.

> - This file should probably not included:

Good catch, fixed.

> - Some parts are also BSD and MIT

Yeah, upon inspection, the licensing is a little crazy.

Comment 4 Lars Kellogg-Stedman 2018-04-11 01:23:15 UTC
Spec URL: https://copr-be.cloud.fedoraproject.org/results/larsks/watchman/fedora-rawhide-x86_64/00739568-watchman/watchman.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/larsks/watchman/fedora-rawhide-x86_64/00739568-watchman/watchman-4.9.0-2.fc29.src.rpm
Description: Watchman exists to watch files and record when they change. It can also trigger actions (such as rebuilding assets) when matching files change.

Comment 5 Robert-André Mauchin 🐧 2018-04-11 14:16:54 UTC
Package approved.

Comment 6 Jon Dufresne 2020-04-23 15:39:25 UTC
IIUC, this package was approved 2018-04-11 any reason it is still not available in the repository?

Comment 7 Mattia Verga 2020-06-14 07:50:35 UTC
This package was approved but never imported. Are you still interested in getting it into Fedora repositories?

Comment 8 Lars Kellogg-Stedman 2020-06-15 13:59:44 UTC
I think we can just cancel this request.

Comment 9 Laurent Rineau 2020-06-15 15:16:13 UTC
Now that the spec file is approved, could this package taken over by an approved maintainer?

Comment 10 Mattia Verga 2020-06-15 16:09:41 UTC
(In reply to Laurent Rineau from comment #9)
> Now that the spec file is approved, could this package taken over by an
> approved maintainer?

Well, I think it must be resubmitted within a new package review request since that spec file was created 2 years ago.
You can ask on the packaging or devel mailing list for info.


Note You need to log in before you can comment on or make changes to this bug.